/* efus.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int efus_c(real *a, integer *m, integer *n, real *b,
        real *c__, real *h__)
{
    /* Initialized data */

    static real zero = 0.f;
    static doublereal dzero = 0.;
    static real one = 1.f;
    static real two = 2.f;
    static integer idate = 60183;

    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2;
    real r__1;
    doublereal d__1;

    /* Builtin functions */
    double log(doublereal), pow_ri(real *, integer *), sqrt(doublereal), 
            r_sign(real *, real *);

    /* Local variables */
    static doublereal dmin__;
    static real rmin;
    static integer i__, j, k, l, i1, j1;
    static real rnorm, r1, r2, r3, r4, r5, r6;
    static integer ii, jj;
    static doublereal rd;
    static integer jn, iswtch;
    static doublereal rd2, ds1, ds2;
    static real sum;

#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]

    /* Parameter adjustments */
    --c__;
    --b;
    a_dim1 = *m;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --h__;

    /* Function Body */
    rnorm = zero;
    if (*m < *n || *n <= 2) {
        goto L30;
    }
    rmin = one;
L1:
    rmin /= two;
    if (one < one + rmin && rmin > zero) {
        goto L1;
    }
/* Computing 2nd power */
    d__1 = (doublereal) rmin;
    dmin__ = d__1 * d__1;
    ds1 = dzero;
    ds2 = dzero;
    sum = zero;
    iswtch = 1;
    r5 = zero;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            r6 = (r__1 = a_ref(i__, j), abs(r__1));
            if (r6 > r5) {
                r5 = r6;
            }
/* L2: */
        }
    }
    rnorm = one;
    if (r5 == zero) {
        goto L32;
    }
    if (r5 * rmin / 128.f * 128.f * rmin > zero) {
        goto L4;
    }
    if (r5 > one) {
        goto L4;
    }
    if (r5 / 128.f == zero) {
        r5 *= 128.f;
    }
    iswtch = ((integer) (-(real)log(r5) / (real)log(two)) + 1) / 2;
    rnorm = (real)pow_ri(&two, &iswtch);
    i__2 = *m;
    for (i__ = 1; i__ <= i__2; ++i__) {
        i__1 = *n;
        for (j = 1; j <= i__1; ++j) {
            a_ref(i__, j) = a_ref(i__, j) * rnorm * rnorm;
/* L3: */
        }
    }
L4:
    h__[32] = rmin;
    h__[33] = rnorm;
    h__[44] = (real) idate;
    jj = 1;
    jn = 2;
    c__[*n] = zero;
L5:
    rd2 = dzero;
    i__1 = *m;
    for (k = jj; k <= i__1; ++k) {
        rd = a_ref(k, jj);
/* L6: */
        rd2 += rd * rd;
    }
L7:
    r2 = rd2;
    ds1 += rd2;
    ds2 -= rd2;
    j = jj;
    jj = jn;
    jn = jj + 1;
    if (ds2 < dmin__ * ds1 && iswtch < 0) {
        goto L28;
    }
    r4 = ds1;
    r4 = rmin * r4 * rmin;
    if (r2 > r4 || iswtch < 0) {
        goto L9;
    }
    sum = r2;
    i__1 = *m;
    for (i1 = j; i1 <= i__1; ++i1) {
        i__2 = *n;
        for (j1 = jj; j1 <= i__2; ++j1) {
/* L8: */
/* Computing 2nd power */
            r__1 = a_ref(i1, j1);
            sum += r__1 * r__1;
        }
    }
    ds2 = sum;
    iswtch = -1;
    h__[34] = (real) j;
    h__[35] = (real) ds1;
    h__[36] = sum;
    if (ds2 <= dmin__ * ds1) {
        goto L28;
    }
L9:
    r1 = a_ref(j, j);
    r__1 = (real)sqrt(r2);
    r3 = (real)r_sign(&r__1, &r1);
    b[j] = -r3;
    l = jj - *n;
    if (r2 < 0.f) {
        goto L30;
    } else if (r2 == 0) {
        goto L16;
    } else {
        goto L10;
    }
L10:
    r1 = (real)sqrt((real)(one + r1 / r3));
    r2 = one / (r3 * r1);
    a_ref(j, j) = r1;
    i__2 = *m;
    for (i__ = jj; i__ <= i__2; ++i__) {
/* L11: */
        a_ref(i__, j) = a_ref(i__, j) * r2;
    }
    if (l <= 0) {
        goto L12;
    } else {
        goto L30;
    }
L12:
    rd2 = dzero;
    i__2 = *n;
    for (k = jj; k <= i__2; ++k) {
        r3 = zero;
        i__1 = *m;
        for (i__ = j; i__ <= i__1; ++i__) {
/* L13: */
            r3 += a_ref(i__, j) * a_ref(i__, k);
        }
        r2 = a_ref(j, k) - r1 * r3;
        a_ref(j, k) = r2;
        rd = r2;
        rd2 += rd * r2;
        i__1 = *m;
        for (i__ = jj; i__ <= i__1; ++i__) {
/* L14: */
            a_ref(i__, k) = a_ref(i__, k) - r3 * a_ref(i__, j);
        }
    }
/* L15: */
    if (l < 0) {
        goto L21;
    } else if (l == 0) {
        goto L18;
    } else {
        goto L30;
    }
L16:
    i__1 = *m;
    for (ii = j; ii <= i__1; ++ii) {
/* L17: */
        a_ref(ii, j) = zero;
    }
    if (l < 0) {
        goto L19;
    } else if (l == 0) {
        goto L18;
    } else {
        goto L30;
    }
L18:
    r3 = a_ref(*n - 1, *n);
    r4 = ds1;
    r4 = rmin * r4 * rmin;
    r3 *= r3;
    if (r3 <= r4 && *m <= *n) {
        a_ref(*n - 1, *n) = zero;
    }
    r3 = a_ref(*n, *n);
    r3 *= r3;
    if (r3 <= r4 && *m <= *n) {
        a_ref(*n, *n) = zero;
    }
    c__[*n - 1] = a_ref(*n - 1, *n);
    b[*n] = a_ref(*n, *n);
    if (*m - *n <= 0) {
        goto L30;
    } else {
        goto L5;
    }
L19:
    rd2 = dzero;
    i__1 = *n;
    for (k = jj; k <= i__1; ++k) {
        rd = a_ref(j, k);
/* L20: */
        rd2 += rd * rd;
    }
L21:
    r2 = rd2;
    ds1 += rd2;
    ds2 -= rd2;
    r1 = a_ref(j, jj);
    r__1 = (real)sqrt(r2);
    r3 = (real)r_sign(&r__1, &r1);
    c__[j] = -r3;
    if (r2 < 0.f) {
        goto L30;
    } else if (r2 == 0) {
        goto L22;
    } else {
        goto L24;
    }
L22:
    i__1 = *n;
    for (ii = jj; ii <= i__1; ++ii) {
/* L23: */
        a_ref(j, ii) = zero;
    }
    goto L5;
L24:
    r1 = (real)sqrt((real)(one + r1 / r3));
    r2 = one / (r3 * r1);
    a_ref(j, jj) = r1;
    i__1 = *n;
    for (k = jn; k <= i__1; ++k) {
/* L25: */
        a_ref(j, k) = a_ref(j, k) * r2;
    }
    rd2 = dzero;
    i__1 = *m;
    for (i__ = jj; i__ <= i__1; ++i__) {
        r3 = zero;
        i__2 = *n;
        for (k = jj; k <= i__2; ++k) {
/* L26: */
            r3 += a_ref(j, k) * a_ref(i__, k);
        }
        r2 = a_ref(i__, jj) - r1 * r3;
        a_ref(i__, jj) = r2;
        rd = r2;
        rd2 += rd * r2;
        i__2 = *n;
        for (k = jn; k <= i__2; ++k) {
/* L27: */
            a_ref(i__, k) = a_ref(i__, k) - r3 * a_ref(j, k);
        }
    }
    goto L7;
L28:
    i__2 = *n;
    for (j1 = j; j1 <= i__2; ++j1) {
        b[j1] = zero;
        c__[j1] = zero;
        i__1 = *m;
        for (i1 = j; i1 <= i__1; ++i1) {
/* L29: */
            a_ref(i1, j1) = zero;
        }
    }
L30:
    if (rnorm == one) {
        goto L32;
    }
    rnorm = one / rnorm;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        b[j] = b[j] * rnorm * rnorm;
        c__[j] = c__[j] * rnorm * rnorm;
/* L31: */
    }
L32:
    return 0;
} /* efus_c */

#undef a_ref
